---
title: HTMLImageElement.decoding
slug: Web/API/HTMLImageElement/decoding
tags:
  - API
  - HTML DOM
  - HTMLImageElement
  - Property
  - Reference
  - decoding
---
<div>{{APIRef}}</div>

<p>The <strong><code>decoding</code></strong> property of the {{domxref("HTMLImageElement")}} interface represents a hint given to the browser on how it should decode the image.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>refStr</var> = <var>imgElem</var>.decoding;
<var>imgElem</var>.decoding = <var>refStr</var>;</pre>

<h3 id="Values">Values</h3>

<p>A {{domxref("DOMString")}} representing the decoding hint. Possible values are:</p>

<dl>
 <dd>
 <ul>
  <li><strong><code>sync</code></strong>: Decode the image synchronously for atomic presentation with other content.</li>
  <li><strong><code>async</code></strong>: Decode the image asynchronously to reduce delay in presenting other content.</li>
  <li><strong><code>auto</code></strong>: Default mode, which indicates no preference for the decoding mode. The browser decides what is best for the user.</li>
 </ul>
 </dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>The <code>decoding</code> property allows you to control whether or not the browser is allowed to try to parallelize loading your image. If doing so would cause problems, you can specify <code>sync</code> to disable asynchronous loading. This can be useful when applied to {{HTMLElement("img")}} elements, but may be even more so when used for offscreen image objects.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js;highlight:[3]">var img = new Image();
img.decoding = 'sync';
img.src = 'img/logo.png';
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'embedded-content.html#dom-img-decoding', 'decoding')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLImageElement.decoding")}}</p>
